ad_page_contract {

    Simple add/edit form for resources

    @author jade@safe4all.org
    @creation-date 2003-08-27
    @cvs-id $Id: type-add-edit.tcl,v 1.3 2004/03/02 21:32:32 jader Exp $

    @return context_bar Context bar.
    @return title Page title.

} {

    resource_revision_id:integer,optional
    {resource_name ""}
    {description ""}
    {categories ""}

} -properties {

    context_bar:onevalue
    title:onevalue

}

# --------------------------------------------------------------- #
# the unique identifier for this package
set package_id [ad_conn package_id]
set user_id    [ad_maybe_redirect_for_registration]


if {[exists_and_not_null resource_id]} {
    set title "Edit a $resource_term_lower"
    set context_bar [ad_context_bar "Edit $resource_term"]

    # permissions
    permission::require_permission -party_id $user_id -object_id $package_id -privilege write
} else {
    set title "Add a resource"
    set context_bar [ad_context_bar "New resource"]

    # permissions
    permission::require_permission -party_id $user_id -object_id $package_id -privilege create
}



ad_form -name add_edit -form {
    resource_revision_id:key

    {resource_name:text
        {label "Resource name"}
        {value $resource_name}
        {html {size 39}}
    }

    {description:text(textarea)
        {label "Description"}
        {optional}
        {value $description}
        {html { rows 5 cols 40 wrap soft}}}

} -select_query_name resource_query -on_submit {

    set user_id [ad_conn user_id]
    set peeraddr [ad_conn peeraddr]

} -new_data {
    set resource_revision_id [db_exec_plsql new_resource_item { *SQL* }]

    ad_returnredirect "one?[export_url_vars resource_revision_id]"
    ad_script_abort

} -edit_data {
    set resource_item_id [db_string get_item_id { }]

    set resource_revision_id [db_exec_plsql new_resource_revision { *SQL* }]

} -after_submit {

    ad_returnredirect "one?[export_url_vars resource_revision_id]"
    ad_script_abort
}



foreach type [db_list_of_lists get_resource_types { } ] {

    set category_type_id [lindex $type 0]
    set type_short_name  [lindex $type 1]

    set options [list]
    db_foreach get_category_items { } {
        lappend options [list $short_name $category_id]
    }

    set select_name "Select: $type_short_name"

    ad_form -extend -name add_edit -form \
        [list \
             [list \
                  categories:text(checkbox),multiple \
                  {label $selectname} \
                  {options [list $options]} \
                  {values $categories} \
                 ] \
            ]

}
